/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.304 Revision 1.370
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.304 2008/09/20 18:45:26 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.370 2011/12/02 10:22:41 ferringb Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18inherit multilib portability user
19 19
20DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
21
22if has "${EAPI:-0}" 0 1 2; then
21 23
22# @FUNCTION: epause 24# @FUNCTION: epause
23# @USAGE: [seconds] 25# @USAGE: [seconds]
24# @DESCRIPTION: 26# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 28# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 30# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 31epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 33}
32 34
33# @FUNCTION: ebeep 35# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 36# @USAGE: [number of beeps]
35# @DESCRIPTION: 37# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 38# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 39# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 41# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 42ebeep() {
41 local n 43 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 46 echo -ne "\a"
47 sleep 1 49 sleep 1
48 done 50 done
49 fi 51 fi
50} 52}
51 53
54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 :
76 }
77fi
78
52# @FUNCTION: ecvs_clean 79# @FUNCTION: ecvs_clean
53# @USAGE: [list of dirs] 80# @USAGE: [list of dirs]
54# @DESCRIPTION: 81# @DESCRIPTION:
55# Remove CVS directories recursiveley. Useful when a source tarball contains 82# Remove CVS directories recursiveley. Useful when a source tarball contains
56# internal CVS directories. Defaults to $PWD. 83# internal CVS directories. Defaults to $PWD.
68esvn_clean() { 95esvn_clean() {
69 [[ -z $* ]] && set -- . 96 [[ -z $* ]] && set -- .
70 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 97 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
71} 98}
72 99
73# Default directory where patches are located 100# @FUNCTION: eshopts_push
101# @USAGE: [options to `set` or `shopt`]
102# @DESCRIPTION:
103# Often times code will want to enable a shell option to change code behavior.
104# Since changing shell options can easily break other pieces of code (which
105# assume the default state), eshopts_push is used to (1) push the current shell
106# options onto a stack and (2) pass the specified arguments to set.
107#
108# If the first argument is '-s' or '-u', we assume you want to call `shopt`
109# rather than `set` as there are some options only available via that.
110#
111# A common example is to disable shell globbing so that special meaning/care
112# may be used with variables/arguments to custom functions. That would be:
113# @CODE
114# eshopts_push -o noglob
115# for x in ${foo} ; do
116# if ...some check... ; then
117# eshopts_pop
118# return 0
119# fi
120# done
121# eshopts_pop
122# @CODE
123eshopts_push() {
124 # have to assume __ESHOPTS_SAVE__ isn't screwed with
125 # as a `declare -a` here will reset its value
126 local i=${#__ESHOPTS_SAVE__[@]}
127 if [[ $1 == -[su] ]] ; then
128 __ESHOPTS_SAVE__[$i]=$(shopt -p)
129 [[ $# -eq 0 ]] && return 0
130 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
131 else
132 __ESHOPTS_SAVE__[$i]=$-
133 [[ $# -eq 0 ]] && return 0
134 set "$@" || die "eshopts_push: bad options to set: $*"
135 fi
136}
137
138# @FUNCTION: eshopts_pop
139# @USAGE:
140# @DESCRIPTION:
141# Restore the shell options to the state saved with the corresponding
142# eshopts_push call. See that function for more details.
143eshopts_pop() {
144 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
145 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
146 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
147 local s=${__ESHOPTS_SAVE__[$i]}
148 unset __ESHOPTS_SAVE__[$i]
149 if [[ ${s} == "shopt -"* ]] ; then
150 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
151 else
152 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
153 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
154 fi
155}
156
157# @VARIABLE: EPATCH_SOURCE
158# @DESCRIPTION:
159# Default directory to search for patches.
74EPATCH_SOURCE="${WORKDIR}/patch" 160EPATCH_SOURCE="${WORKDIR}/patch"
75# Default extension for patches 161# @VARIABLE: EPATCH_SUFFIX
162# @DESCRIPTION:
163# Default extension for patches (do not prefix the period yourself).
76EPATCH_SUFFIX="patch.bz2" 164EPATCH_SUFFIX="patch.bz2"
165# @VARIABLE: EPATCH_OPTS
166# @DESCRIPTION:
77# Default options for patch 167# Default options for patch:
168# @CODE
78# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 169# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
79# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 170# --no-backup-if-mismatch - do not leave .orig files behind
80# Set -E to automatically remove empty files. 171# -E - automatically remove empty files
172# @CODE
81EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 173EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
174# @VARIABLE: EPATCH_EXCLUDE
175# @DESCRIPTION:
82# List of patches not to apply. Not this is only file names, 176# List of patches not to apply. Note this is only file names,
83# and not the full path .. 177# and not the full path. Globs accepted.
84EPATCH_EXCLUDE="" 178EPATCH_EXCLUDE=""
179# @VARIABLE: EPATCH_SINGLE_MSG
180# @DESCRIPTION:
85# Change the printed message for a single patch. 181# Change the printed message for a single patch.
86EPATCH_SINGLE_MSG="" 182EPATCH_SINGLE_MSG=""
183# @VARIABLE: EPATCH_MULTI_MSG
184# @DESCRIPTION:
87# Change the printed message for multiple patches. 185# Change the printed message for multiple patches.
88EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 186EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
89# Force applying bulk patches even if not following the style: 187# @VARIABLE: EPATCH_FORCE
90# 188# @DESCRIPTION:
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 189# Only require patches to match EPATCH_SUFFIX rather than the extended
92# 190# arch naming style.
93EPATCH_FORCE="no" 191EPATCH_FORCE="no"
94 192
95# This function is for bulk patching, or in theory for just one 193# @FUNCTION: epatch
96# or two patches. 194# @USAGE: [patches] [dirs of patches]
195# @DESCRIPTION:
196# epatch is designed to greatly simplify the application of patches. It can
197# process patch files directly, or directories of patches. The patches may be
198# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
199# the -p option as epatch will automatically attempt -p0 to -p5 until things
200# apply successfully.
97# 201#
98# It should work with .bz2, .gz, .zip and plain text patches. 202# If you do not specify any options, then epatch will default to the directory
99# Currently all patches should be the same format. 203# specified by EPATCH_SOURCE.
100# 204#
101# You do not have to specify '-p' option to patch, as it will 205# When processing directories, epatch will apply all patches that match:
102# try with -p0 to -p5 until it succeed, or fail at -p5. 206# @CODE
103# 207# if ${EPATCH_FORCE} != "yes"
104# Above EPATCH_* variables can be used to control various defaults,
105# bug they should be left as is to ensure an ebuild can rely on
106# them for.
107#
108# Patches are applied in current directory.
109#
110# Bulk Patches should preferibly have the form of:
111#
112# ??_${ARCH}_foo.${EPATCH_SUFFIX} 208# ??_${ARCH}_foo.${EPATCH_SUFFIX}
209# else
210# *.${EPATCH_SUFFIX}
211# @CODE
212# The leading ?? are typically numbers used to force consistent patch ordering.
213# The arch field is used to apply patches only for the host architecture with
214# the special value of "all" means apply for everyone. Note that using values
215# other than "all" is highly discouraged -- you should apply patches all the
216# time and let architecture details be detected at configure/compile time.
113# 217#
114# For example: 218# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
219# for patches to apply.
115# 220#
116# 01_all_misc-fix.patch.bz2 221# Refer to the other EPATCH_xxx variables for more customization of behavior.
117# 02_sparc_another-fix.patch.bz2
118#
119# This ensures that there are a set order, and you can have ARCH
120# specific patches.
121#
122# If you however give an argument to epatch(), it will treat it as a
123# single patch that need to be applied if its a file. If on the other
124# hand its a directory, it will set EPATCH_SOURCE to this.
125#
126# <azarah@gentoo.org> (10 Nov 2002)
127#
128epatch() { 222epatch() {
129 _epatch_draw_line() { 223 _epatch_draw_line() {
224 # create a line of same length as input string
130 [[ -z $1 ]] && set "$(printf "%65s" '')" 225 [[ -z $1 ]] && set "$(printf "%65s" '')"
131 echo "${1//?/=}" 226 echo "${1//?/=}"
132 } 227 }
133 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
134 local PIPE_CMD=""
135 local STDERR_TARGET="${T}/$$.out"
136 local PATCH_TARGET="${T}/$$.patch"
137 local PATCH_SUFFIX=""
138 local SINGLE_PATCH="no"
139 local x=""
140 228
141 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 229 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
142 230
143 if [ "$#" -gt 1 ] 231 # Let the rest of the code process one user arg at a time --
144 then 232 # each arg may expand into multiple patches, and each arg may
233 # need to start off with the default global EPATCH_xxx values
234 if [[ $# -gt 1 ]] ; then
145 local m="" 235 local m
146 for m in "$@" ; do 236 for m in "$@" ; do
147 epatch "${m}" 237 epatch "${m}"
148 done 238 done
149 return 0 239 return 0
150 fi 240 fi
151 241
152 if [ -n "$1" -a -f "$1" ] 242 local SINGLE_PATCH="no"
153 then 243 # no args means process ${EPATCH_SOURCE}
244 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
245
246 if [[ -f $1 ]] ; then
154 SINGLE_PATCH="yes" 247 SINGLE_PATCH="yes"
155 248 set -- "$1"
156 local EPATCH_SOURCE="$1" 249 # Use the suffix from the single patch (localize it); the code
250 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 251 local EPATCH_SUFFIX=$1
158 252
159 elif [ -n "$1" -a -d "$1" ] 253 elif [[ -d $1 ]] ; then
160 then 254 # Some people like to make dirs of patches w/out suffixes (vim)
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 255 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 256
257 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
258 # Re-use EPATCH_SOURCE as a search dir
259 epatch "${EPATCH_SOURCE}/$1"
260 return $?
261
262 else
263 # sanity check ... if it isn't a dir or file, wtf man ?
264 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
265 echo
266 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
267 eerror
268 eerror " ${EPATCH_SOURCE}"
269 eerror " ( ${EPATCH_SOURCE##*/} )"
270 echo
271 die "Cannot find \$EPATCH_SOURCE!"
272 fi
273
274 local PIPE_CMD
275 case ${EPATCH_SUFFIX##*\.} in
276 xz) PIPE_CMD="xz -dc" ;;
277 lzma) PIPE_CMD="lzma -dc" ;;
278 bz2) PIPE_CMD="bzip2 -dc" ;;
279 gz|Z|z) PIPE_CMD="gzip -dc" ;;
280 ZIP|zip) PIPE_CMD="unzip -p" ;;
281 *) ;;
282 esac
283
284 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
285
286 local x
287 for x in "$@" ; do
288 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
289 # didn't match anything, ignore continue on
290 [[ ! -f ${x} ]] && continue
291
292 local patchname=${x##*/}
293
294 # Apply single patches, or forced sets of patches, or
295 # patches with ARCH dependant names.
296 # ???_arch_foo.patch
297 # Else, skip this input altogether
298 local a=${patchname#*_} # strip the ???_
299 a=${a%%_*} # strip the _foo.patch
300 if ! [[ ${SINGLE_PATCH} == "yes" || \
301 ${EPATCH_FORCE} == "yes" || \
302 ${a} == all || \
303 ${a} == ${ARCH} ]]
163 then 304 then
164 local EPATCH_SOURCE="$1/*" 305 continue
306 fi
307
308 # Let people filter things dynamically
309 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
310 # let people use globs in the exclude
311 eshopts_push -o noglob
312
313 local ex
314 for ex in ${EPATCH_EXCLUDE} ; do
315 if [[ ${patchname} == ${ex} ]] ; then
316 eshopts_pop
317 continue 2
318 fi
319 done
320
321 eshopts_pop
322 fi
323
324 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
325 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
326 einfo "${EPATCH_SINGLE_MSG}"
327 else
328 einfo "Applying ${patchname} ..."
329 fi
165 else 330 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 331 einfo " ${patchname} ..."
167 fi 332 fi
168 else 333
169 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 334 # most of the time, there will only be one run per unique name,
170 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 335 # but if there are more, make sure we get unique log filenames
171 then 336 local STDERR_TARGET="${T}/${patchname}.out"
172 EPATCH_SOURCE="$1" 337 if [[ -e ${STDERR_TARGET} ]] ; then
338 STDERR_TARGET="${T}/${patchname}-$$.out"
339 fi
340
341 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
342
343 # Decompress the patch if need be
344 local count=0
345 local PATCH_TARGET
346 if [[ -n ${PIPE_CMD} ]] ; then
347 PATCH_TARGET="${T}/$$.patch"
348 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
349
350 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
351 echo
352 eerror "Could not extract patch!"
353 #die "Could not extract patch!"
354 count=5
355 break
173 fi 356 fi
357 else
358 PATCH_TARGET=${x}
359 fi
174 360
361 # Check for absolute paths in patches. If sandbox is disabled,
362 # people could (accidently) patch files in the root filesystem.
363 # Or trigger other unpleasantries #237667. So disallow -p0 on
364 # such patches.
365 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
366 if [[ -n ${abs_paths} ]] ; then
367 count=1
368 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
369 fi
370 # Similar reason, but with relative paths.
371 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
372 if [[ -n ${rel_paths} ]] ; then
373 eqawarn "QA Notice: Your patch uses relative paths '../'."
374 eqawarn " In the future this will cause a failure."
375 eqawarn "${rel_paths}"
376 fi
377
378 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
379 while [[ ${count} -lt 5 ]] ; do
380 # Generate some useful debug info ...
381 (
382 _epatch_draw_line "***** ${patchname} *****"
175 echo 383 echo
176 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 384 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
385 echo
386 _epatch_draw_line "***** ${patchname} *****"
387 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
388 ret=$?
389 echo
390 echo "patch program exited with status ${ret}"
391 exit ${ret}
392 ) >> "${STDERR_TARGET}"
393
394 if [ $? -eq 0 ] ; then
395 (
396 _epatch_draw_line "***** ${patchname} *****"
397 echo
398 echo "ACTUALLY APPLYING ${patchname} ..."
399 echo
400 _epatch_draw_line "***** ${patchname} *****"
401 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
402 ret=$?
403 echo
404 echo "patch program exited with status ${ret}"
405 exit ${ret}
406 ) >> "${STDERR_TARGET}"
407
408 if [ $? -ne 0 ] ; then
409 echo
410 eerror "A dry-run of patch command succeeded, but actually"
411 eerror "applying the patch failed!"
412 #die "Real world sux compared to the dreamworld!"
413 count=5
414 fi
415 break
416 fi
417
418 : $(( count++ ))
419 done
420
421 # if we had to decompress the patch, delete the temp one
422 if [[ -n ${PIPE_CMD} ]] ; then
423 rm -f "${PATCH_TARGET}"
424 fi
425
426 if [[ ${count} -ge 5 ]] ; then
427 echo
428 eerror "Failed Patch: ${patchname} !"
429 eerror " ( ${PATCH_TARGET} )"
177 eerror 430 eerror
178 eerror " ${EPATCH_SOURCE}" 431 eerror "Include in your bugreport the contents of:"
179 eerror " ( ${EPATCH_SOURCE##*/} )" 432 eerror
433 eerror " ${STDERR_TARGET}"
180 echo 434 echo
181 die "Cannot find \$EPATCH_SOURCE!"
182 fi
183
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
185 fi
186
187 case ${EPATCH_SUFFIX##*\.} in
188 lzma)
189 PIPE_CMD="lzma -dc"
190 PATCH_SUFFIX="lzma"
191 ;;
192 bz2)
193 PIPE_CMD="bzip2 -dc"
194 PATCH_SUFFIX="bz2"
195 ;;
196 gz|Z|z)
197 PIPE_CMD="gzip -dc"
198 PATCH_SUFFIX="gz"
199 ;;
200 ZIP|zip)
201 PIPE_CMD="unzip -p"
202 PATCH_SUFFIX="zip"
203 ;;
204 *)
205 PIPE_CMD="cat"
206 PATCH_SUFFIX="patch"
207 ;;
208 esac
209
210 if [ "${SINGLE_PATCH}" = "no" ]
211 then
212 einfo "${EPATCH_MULTI_MSG}"
213 fi
214 for x in ${EPATCH_SOURCE}
215 do
216 # New ARCH dependant patch naming scheme ...
217 #
218 # ???_arch_foo.patch
219 #
220 if [ -f ${x} ] && \
221 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
222 [ "${EPATCH_FORCE}" = "yes" ])
223 then
224 local count=0
225 local popts="${EPATCH_OPTS}"
226 local patchname=${x##*/}
227
228 if [ -n "${EPATCH_EXCLUDE}" ]
229 then
230 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
231 then
232 continue
233 fi
234 fi
235
236 if [ "${SINGLE_PATCH}" = "yes" ]
237 then
238 if [ -n "${EPATCH_SINGLE_MSG}" ]
239 then
240 einfo "${EPATCH_SINGLE_MSG}"
241 else
242 einfo "Applying ${patchname} ..."
243 fi
244 else
245 einfo " ${patchname} ..."
246 fi
247
248 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
249 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
250
251 # Decompress the patch if need be
252 if [[ ${PATCH_SUFFIX} != "patch" ]] ; then
253 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
254 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
255
256 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 ; then
257 echo
258 eerror "Could not extract patch!"
259 #die "Could not extract patch!"
260 count=5
261 break
262 fi
263 else
264 PATCH_TARGET="${x}"
265 fi
266
267 # Allow for prefix to differ ... im lazy, so shoot me :/
268 while [ "${count}" -lt 5 ]
269 do
270 # Generate some useful debug info ...
271 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
272 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273
274 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276
277 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
278 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279
280 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
281 then
282 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
283 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
284 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
285 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
286 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
287
288 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
289 _epatch_assert
290
291 if [ "$?" -ne 0 ]
292 then
293 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
294 echo
295 eerror "A dry-run of patch command succeeded, but actually"
296 eerror "applying the patch failed!"
297 #die "Real world sux compared to the dreamworld!"
298 count=5
299 fi
300
301 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302
303 break
304 fi
305
306 count=$((count + 1))
307 done
308
309 if [ "${PATCH_SUFFIX}" != "patch" ]
310 then
311 rm -f ${PATCH_TARGET}
312 fi
313
314 if [ "${count}" -eq 5 ]
315 then
316 echo
317 eerror "Failed Patch: ${patchname} !"
318 eerror " ( ${PATCH_TARGET} )"
319 eerror
320 eerror "Include in your bugreport the contents of:"
321 eerror
322 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
323 echo
324 die "Failed Patch: ${patchname}!" 435 die "Failed Patch: ${patchname}!"
325 fi 436 fi
326 437
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 438 # if everything worked, delete the patch log
328 439 rm -f "${STDERR_TARGET}"
329 eend 0 440 eend 0
330 fi
331 done 441 done
332 if [ "${SINGLE_PATCH}" = "no" ] 442
333 then 443 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
334 einfo "Done with patching" 444 : # everything worked
445}
446
447# @FUNCTION: epatch_user
448# @USAGE:
449# @DESCRIPTION:
450# Applies user-provided patches to the source tree. The patches are
451# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
452# of these three directories to exist will be the one to use, ignoring
453# any more general directories which might exist as well.
454#
455# User patches are intended for quick testing of patches without ebuild
456# modifications, as well as for permanent customizations a user might
457# desire. Obviously, there can be no official support for arbitrarily
458# patched ebuilds. So whenever a build log in a bug report mentions that
459# user patches were applied, the user should be asked to reproduce the
460# problem without these.
461#
462# Not all ebuilds do call this function, so placing patches in the
463# stated directory might or might not work, depending on the package and
464# the eclasses it inherits and uses. It is safe to call the function
465# repeatedly, so it is always possible to add a call at the ebuild
466# level. The first call is the time when the patches will be
467# applied.
468#
469# Ideally, this function should be called after gentoo-specific patches
470# have been applied, so that their code can be modified as well, but
471# before calls to e.g. eautoreconf, as the user patches might affect
472# autotool input files as well.
473epatch_user() {
474 [[ $# -ne 0 ]] && die "epatch_user takes no options"
475
476 # Allow multiple calls to this function; ignore all but the first
477 local applied="${T}/epatch_user.applied"
478 [[ -e ${applied} ]] && return 2
479
480 # don't clobber any EPATCH vars that the parent might want
481 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
482 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
483 EPATCH_SOURCE=${base}/${CTARGET}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
485 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
486 if [[ -d ${EPATCH_SOURCE} ]] ; then
487 EPATCH_SOURCE=${EPATCH_SOURCE} \
488 EPATCH_SUFFIX="patch" \
489 EPATCH_FORCE="yes" \
490 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
491 epatch
492 echo "${EPATCH_SOURCE}" > "${applied}"
493 return 0
335 fi 494 fi
495 done
496 echo "none" > "${applied}"
497 return 1
336} 498}
337 499
338# @FUNCTION: emktemp 500# @FUNCTION: emktemp
339# @USAGE: [temp dir] 501# @USAGE: [temp dir]
340# @DESCRIPTION: 502# @DESCRIPTION:
368 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 530 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
369 fi 531 fi
370 fi 532 fi
371} 533}
372 534
373# @FUNCTION: egetent
374# @USAGE: <database> <key>
375# @MAINTAINER:
376# base-system@gentoo.org (Linux)
377# Joe Jezak <josejx@gmail.com> (OS X)
378# usata@gentoo.org (OS X)
379# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
380# @DESCRIPTION:
381# Small wrapper for getent (Linux), nidump (Mac OS X),
382# and pw (FreeBSD) used in enewuser()/enewgroup()
383egetent() {
384 case ${CHOST} in
385 *-darwin*)
386 case "$2" in
387 *[!0-9]*) # Non numeric
388 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
389 ;;
390 *) # Numeric
391 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
392 ;;
393 esac
394 ;;
395 *-freebsd*|*-dragonfly*)
396 local opts action="user"
397 [[ $1 == "passwd" ]] || action="group"
398
399 # lookup by uid/gid
400 if [[ $2 == [[:digit:]]* ]] ; then
401 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
402 fi
403
404 pw show ${action} ${opts} "$2" -q
405 ;;
406 *-netbsd*|*-openbsd*)
407 grep "$2:\*:" /etc/$1
408 ;;
409 *)
410 type -p nscd >& /dev/null && nscd -i "$1"
411 getent "$1" "$2"
412 ;;
413 esac
414}
415
416# @FUNCTION: enewuser
417# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
418# @DESCRIPTION:
419# Same as enewgroup, you are not required to understand how to properly add
420# a user to the system. The only required parameter is the username.
421# Default uid is (pass -1 for this) next available, default shell is
422# /bin/false, default homedir is /dev/null, there are no default groups,
423# and default params sets the comment as 'added by portage for ${PN}'.
424enewuser() {
425 case ${EBUILD_PHASE} in
426 unpack|compile|test|install)
427 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
428 eerror "Package fails at QA and at life. Please file a bug."
429 die "Bad package! enewuser is only for use in pkg_* functions!"
430 esac
431
432 # get the username
433 local euser=$1; shift
434 if [[ -z ${euser} ]] ; then
435 eerror "No username specified !"
436 die "Cannot call enewuser without a username"
437 fi
438
439 # lets see if the username already exists
440 if [[ -n $(egetent passwd "${euser}") ]] ; then
441 return 0
442 fi
443 einfo "Adding user '${euser}' to your system ..."
444
445 # options to pass to useradd
446 local opts=
447
448 # handle uid
449 local euid=$1; shift
450 if [[ -n ${euid} && ${euid} != -1 ]] ; then
451 if [[ ${euid} -gt 0 ]] ; then
452 if [[ -n $(egetent passwd ${euid}) ]] ; then
453 euid="next"
454 fi
455 else
456 eerror "Userid given but is not greater than 0 !"
457 die "${euid} is not a valid UID"
458 fi
459 else
460 euid="next"
461 fi
462 if [[ ${euid} == "next" ]] ; then
463 for ((euid = 101; euid <= 999; euid++)); do
464 [[ -z $(egetent passwd ${euid}) ]] && break
465 done
466 fi
467 opts="${opts} -u ${euid}"
468 einfo " - Userid: ${euid}"
469
470 # handle shell
471 local eshell=$1; shift
472 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
473 if [[ ! -e ${ROOT}${eshell} ]] ; then
474 eerror "A shell was specified but it does not exist !"
475 die "${eshell} does not exist in ${ROOT}"
476 fi
477 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
478 eerror "Do not specify ${eshell} yourself, use -1"
479 die "Pass '-1' as the shell parameter"
480 fi
481 else
482 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
483 [[ -x ${ROOT}${shell} ]] && break
484 done
485
486 if [[ ${shell} == "/dev/null" ]] ; then
487 eerror "Unable to identify the shell to use, proceeding with userland default."
488 case ${USERLAND} in
489 GNU) shell="/bin/false" ;;
490 BSD) shell="/sbin/nologin" ;;
491 Darwin) shell="/usr/sbin/nologin" ;;
492 *) die "Unable to identify the default shell for userland ${USERLAND}"
493 esac
494 fi
495
496 eshell=${shell}
497 fi
498 einfo " - Shell: ${eshell}"
499 opts="${opts} -s ${eshell}"
500
501 # handle homedir
502 local ehome=$1; shift
503 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
504 ehome="/dev/null"
505 fi
506 einfo " - Home: ${ehome}"
507 opts="${opts} -d ${ehome}"
508
509 # handle groups
510 local egroups=$1; shift
511 if [[ ! -z ${egroups} ]] ; then
512 local oldifs=${IFS}
513 local defgroup="" exgroups=""
514
515 export IFS=","
516 for g in ${egroups} ; do
517 export IFS=${oldifs}
518 if [[ -z $(egetent group "${g}") ]] ; then
519 eerror "You must add group ${g} to the system first"
520 die "${g} is not a valid GID"
521 fi
522 if [[ -z ${defgroup} ]] ; then
523 defgroup=${g}
524 else
525 exgroups="${exgroups},${g}"
526 fi
527 export IFS=","
528 done
529 export IFS=${oldifs}
530
531 opts="${opts} -g ${defgroup}"
532 if [[ ! -z ${exgroups} ]] ; then
533 opts="${opts} -G ${exgroups:1}"
534 fi
535 else
536 egroups="(none)"
537 fi
538 einfo " - Groups: ${egroups}"
539
540 # handle extra and add the user
541 local oldsandbox=${SANDBOX_ON}
542 export SANDBOX_ON="0"
543 case ${CHOST} in
544 *-darwin*)
545 ### Make the user
546 if [[ -z $@ ]] ; then
547 dscl . create /users/${euser} uid ${euid}
548 dscl . create /users/${euser} shell ${eshell}
549 dscl . create /users/${euser} home ${ehome}
550 dscl . create /users/${euser} realname "added by portage for ${PN}"
551 ### Add the user to the groups specified
552 local oldifs=${IFS}
553 export IFS=","
554 for g in ${egroups} ; do
555 dscl . merge /groups/${g} users ${euser}
556 done
557 export IFS=${oldifs}
558 else
559 einfo "Extra options are not supported on Darwin yet"
560 einfo "Please report the ebuild along with the info below"
561 einfo "eextra: $@"
562 die "Required function missing"
563 fi
564 ;;
565 *-freebsd*|*-dragonfly*)
566 if [[ -z $@ ]] ; then
567 pw useradd ${euser} ${opts} \
568 -c "added by portage for ${PN}" \
569 die "enewuser failed"
570 else
571 einfo " - Extra: $@"
572 pw useradd ${euser} ${opts} \
573 "$@" || die "enewuser failed"
574 fi
575 ;;
576
577 *-netbsd*)
578 if [[ -z $@ ]] ; then
579 useradd ${opts} ${euser} || die "enewuser failed"
580 else
581 einfo " - Extra: $@"
582 useradd ${opts} ${euser} "$@" || die "enewuser failed"
583 fi
584 ;;
585
586 *-openbsd*)
587 if [[ -z $@ ]] ; then
588 useradd -u ${euid} -s ${eshell} \
589 -d ${ehome} -c "Added by portage for ${PN}" \
590 -g ${egroups} ${euser} || die "enewuser failed"
591 else
592 einfo " - Extra: $@"
593 useradd -u ${euid} -s ${eshell} \
594 -d ${ehome} -c "Added by portage for ${PN}" \
595 -g ${egroups} ${euser} "$@" || die "enewuser failed"
596 fi
597 ;;
598
599 *)
600 if [[ -z $@ ]] ; then
601 useradd ${opts} ${euser} \
602 -c "added by portage for ${PN}" \
603 || die "enewuser failed"
604 else
605 einfo " - Extra: $@"
606 useradd ${opts} ${euser} "$@" \
607 || die "enewuser failed"
608 fi
609 ;;
610 esac
611
612 if [[ ! -e ${ROOT}/${ehome} ]] ; then
613 einfo " - Creating ${ehome} in ${ROOT}"
614 mkdir -p "${ROOT}/${ehome}"
615 chown ${euser} "${ROOT}/${ehome}"
616 chmod 755 "${ROOT}/${ehome}"
617 fi
618
619 export SANDBOX_ON=${oldsandbox}
620}
621
622# @FUNCTION: enewgroup
623# @USAGE: <group> [gid]
624# @DESCRIPTION:
625# This function does not require you to understand how to properly add a
626# group to the system. Just give it a group name to add and enewgroup will
627# do the rest. You may specify the gid for the group or allow the group to
628# allocate the next available one.
629enewgroup() {
630 case ${EBUILD_PHASE} in
631 unpack|compile|test|install)
632 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
633 eerror "Package fails at QA and at life. Please file a bug."
634 die "Bad package! enewgroup is only for use in pkg_* functions!"
635 esac
636
637 # get the group
638 local egroup="$1"; shift
639 if [ -z "${egroup}" ]
640 then
641 eerror "No group specified !"
642 die "Cannot call enewgroup without a group"
643 fi
644
645 # see if group already exists
646 if [[ -n $(egetent group "${egroup}") ]]; then
647 return 0
648 fi
649 einfo "Adding group '${egroup}' to your system ..."
650
651 # options to pass to useradd
652 local opts=
653
654 # handle gid
655 local egid="$1"; shift
656 if [ ! -z "${egid}" ]
657 then
658 if [ "${egid}" -gt 0 ]
659 then
660 if [ -z "`egetent group ${egid}`" ]
661 then
662 if [[ "${CHOST}" == *-darwin* ]]; then
663 opts="${opts} ${egid}"
664 else
665 opts="${opts} -g ${egid}"
666 fi
667 else
668 egid="next available; requested gid taken"
669 fi
670 else
671 eerror "Groupid given but is not greater than 0 !"
672 die "${egid} is not a valid GID"
673 fi
674 else
675 egid="next available"
676 fi
677 einfo " - Groupid: ${egid}"
678
679 # handle extra
680 local eextra="$@"
681 opts="${opts} ${eextra}"
682
683 # add the group
684 local oldsandbox="${SANDBOX_ON}"
685 export SANDBOX_ON="0"
686 case ${CHOST} in
687 *-darwin*)
688 if [ ! -z "${eextra}" ];
689 then
690 einfo "Extra options are not supported on Darwin/OS X yet"
691 einfo "Please report the ebuild along with the info below"
692 einfo "eextra: ${eextra}"
693 die "Required function missing"
694 fi
695
696 # If we need the next available
697 case ${egid} in
698 *[!0-9]*) # Non numeric
699 for ((egid = 101; egid <= 999; egid++)); do
700 [[ -z $(egetent group ${egid}) ]] && break
701 done
702 esac
703 dscl . create /groups/${egroup} gid ${egid}
704 dscl . create /groups/${egroup} passwd '*'
705 ;;
706
707 *-freebsd*|*-dragonfly*)
708 case ${egid} in
709 *[!0-9]*) # Non numeric
710 for ((egid = 101; egid <= 999; egid++)); do
711 [[ -z $(egetent group ${egid}) ]] && break
712 done
713 esac
714 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
715 ;;
716
717 *-netbsd*)
718 case ${egid} in
719 *[!0-9]*) # Non numeric
720 for ((egid = 101; egid <= 999; egid++)); do
721 [[ -z $(egetent group ${egid}) ]] && break
722 done
723 esac
724 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
725 ;;
726
727 *)
728 groupadd ${opts} ${egroup} || die "enewgroup failed"
729 ;;
730 esac
731 export SANDBOX_ON="${oldsandbox}"
732}
733
734# @FUNCTION: edos2unix 535# @FUNCTION: edos2unix
735# @USAGE: <file> [more files ...] 536# @USAGE: <file> [more files ...]
736# @DESCRIPTION: 537# @DESCRIPTION:
737# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 538# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
738# to remove all of these text utilities from DEPEND variables because this 539# to remove all of these text utilities from DEPEND variables because this
739# is a script based solution. Just give it a list of files to convert and 540# is a script based solution. Just give it a list of files to convert and
740# they will all be changed from the DOS CRLF format to the UNIX LF format. 541# they will all be changed from the DOS CRLF format to the UNIX LF format.
741edos2unix() { 542edos2unix() {
742 echo "$@" | xargs sed -i 's/\r$//' 543 [[ $# -eq 0 ]] && return 0
544 sed -i 's/\r$//' -- "$@" || die
743} 545}
744 546
745# Make a desktop file ! 547# Make a desktop file !
746# Great for making those icons in kde/gnome startmenu ! 548# Great for making those icons in kde/gnome startmenu !
747# Amaze your friends ! Get the women ! Join today ! 549# Amaze your friends ! Get the women ! Join today !
748# 550#
749# make_desktop_entry(<command>, [name], [icon], [type], [path]) 551# make_desktop_entry(<command>, [name], [icon], [type], [fields])
750# 552#
751# binary: what command does the app run with ? 553# binary: what command does the app run with ?
752# name: the name that will show up in the menu 554# name: the name that will show up in the menu
753# icon: give your little like a pretty little icon ... 555# icon: give your little like a pretty little icon ...
754# this can be relative (to /usr/share/pixmaps) or 556# this can be relative (to /usr/share/pixmaps) or
755# a full path to an icon 557# a full path to an icon
756# type: what kind of application is this ? for categories: 558# type: what kind of application is this ? for categories:
757# http://standards.freedesktop.org/menu-spec/latest/apa.html 559# http://standards.freedesktop.org/menu-spec/latest/apa.html
758# path: if your app needs to startup in a specific dir 560# fields: extra fields to append to the desktop file; a printf string
759make_desktop_entry() { 561make_desktop_entry() {
760 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 562 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
761 563
762 local exec=${1} 564 local exec=${1}
763 local name=${2:-${PN}} 565 local name=${2:-${PN}}
764 local icon=${3:-${PN}} 566 local icon=${3:-${PN}}
765 local type=${4} 567 local type=${4}
766 local path=${5} 568 local fields=${5}
767 569
768 if [[ -z ${type} ]] ; then 570 if [[ -z ${type} ]] ; then
769 local catmaj=${CATEGORY%%-*} 571 local catmaj=${CATEGORY%%-*}
770 local catmin=${CATEGORY##*-} 572 local catmin=${CATEGORY##*-}
771 case ${catmaj} in 573 case ${catmaj} in
772 app) 574 app)
773 case ${catmin} in 575 case ${catmin} in
774 accessibility) type=Accessibility;; 576 accessibility) type=Accessibility;;
775 admin) type=System;; 577 admin) type=System;;
776 antivirus) type=System;; 578 antivirus) type=System;;
777 arch) type=Archiving;; 579 arch) type=Archiving;;
778 backup) type=Archiving;; 580 backup) type=Archiving;;
779 cdr) type=DiscBurning;; 581 cdr) type=DiscBurning;;
780 dicts) type=Dictionary;; 582 dicts) type=Dictionary;;
781 doc) type=Documentation;; 583 doc) type=Documentation;;
782 editors) type=TextEditor;; 584 editors) type=TextEditor;;
783 emacs) type=TextEditor;; 585 emacs) type=TextEditor;;
784 emulation) type=Emulator;; 586 emulation) type=Emulator;;
785 laptop) type=HardwareSettings;; 587 laptop) type=HardwareSettings;;
786 office) type=Office;; 588 office) type=Office;;
787 pda) type=PDA;; 589 pda) type=PDA;;
788 vim) type=TextEditor;; 590 vim) type=TextEditor;;
789 xemacs) type=TextEditor;; 591 xemacs) type=TextEditor;;
790 *) type=;;
791 esac 592 esac
792 ;; 593 ;;
793 594
794 dev) 595 dev)
795 type="Development" 596 type="Development"
796 ;; 597 ;;
797 598
798 games) 599 games)
799 case ${catmin} in 600 case ${catmin} in
800 action|fps) type=ActionGame;; 601 action|fps) type=ActionGame;;
801 arcade) type=ArcadeGame;; 602 arcade) type=ArcadeGame;;
802 board) type=BoardGame;; 603 board) type=BoardGame;;
803 emulation) type=Emulator;; 604 emulation) type=Emulator;;
804 kids) type=KidsGame;; 605 kids) type=KidsGame;;
805 puzzle) type=LogicGame;; 606 puzzle) type=LogicGame;;
806 roguelike) type=RolePlaying;; 607 roguelike) type=RolePlaying;;
807 rpg) type=RolePlaying;; 608 rpg) type=RolePlaying;;
808 simulation) type=Simulation;; 609 simulation) type=Simulation;;
809 sports) type=SportsGame;; 610 sports) type=SportsGame;;
810 strategy) type=StrategyGame;; 611 strategy) type=StrategyGame;;
811 *) type=;;
812 esac 612 esac
813 type="Game;${type}" 613 type="Game;${type}"
814 ;; 614 ;;
815 615
816 gnome) 616 gnome)
825 type="Network;Email" 625 type="Network;Email"
826 ;; 626 ;;
827 627
828 media) 628 media)
829 case ${catmin} in 629 case ${catmin} in
630 gfx)
830 gfx) type=Graphics;; 631 type=Graphics
632 ;;
633 *)
634 case ${catmin} in
831 radio) type=Tuner;; 635 radio) type=Tuner;;
832 sound) type=Audio;; 636 sound) type=Audio;;
833 tv) type=TV;; 637 tv) type=TV;;
834 video) type=Video;; 638 video) type=Video;;
835 *) type=;; 639 esac
640 type="AudioVideo;${type}"
641 ;;
836 esac 642 esac
837 type="AudioVideo;${type}"
838 ;; 643 ;;
839 644
840 net) 645 net)
841 case ${catmin} in 646 case ${catmin} in
842 dialup) type=Dialup;; 647 dialup) type=Dialup;;
843 ftp) type=FileTransfer;; 648 ftp) type=FileTransfer;;
844 im) type=InstantMessaging;; 649 im) type=InstantMessaging;;
845 irc) type=IRCClient;; 650 irc) type=IRCClient;;
846 mail) type=Email;; 651 mail) type=Email;;
847 news) type=News;; 652 news) type=News;;
848 nntp) type=News;; 653 nntp) type=News;;
849 p2p) type=FileTransfer;; 654 p2p) type=FileTransfer;;
850 *) type=;; 655 voip) type=Telephony;;
851 esac 656 esac
852 type="Network;${type}" 657 type="Network;${type}"
853 ;; 658 ;;
854 659
855 sci) 660 sci)
856 case ${catmin} in 661 case ${catmin} in
857 astro*) type=Astronomy;; 662 astro*) type=Astronomy;;
858 bio*) type=Biology;; 663 bio*) type=Biology;;
859 calc*) type=Calculator;; 664 calc*) type=Calculator;;
860 chem*) type=Chemistry;; 665 chem*) type=Chemistry;;
861 elec*) type=Electronics;; 666 elec*) type=Electronics;;
862 geo*) type=Geology;; 667 geo*) type=Geology;;
863 math*) type=Math;; 668 math*) type=Math;;
864 physics) type=Physics;; 669 physics) type=Physics;;
865 visual*) type=DataVisualization;; 670 visual*) type=DataVisualization;;
866 *) type=;;
867 esac 671 esac
868 type="Science;${type}" 672 type="Education;Science;${type}"
869 ;; 673 ;;
870 674
871 sys) 675 sys)
872 type="System" 676 type="System"
873 ;; 677 ;;
874 678
875 www) 679 www)
876 case ${catmin} in 680 case ${catmin} in
877 client) type=WebBrowser;; 681 client) type=WebBrowser;;
878 *) type=;;
879 esac 682 esac
880 type="Network" 683 type="Network;${type}"
881 ;; 684 ;;
882 685
883 *) 686 *)
884 type= 687 type=
885 ;; 688 ;;
891 local desktop_name="${PN}-${SLOT}" 694 local desktop_name="${PN}-${SLOT}"
892 fi 695 fi
893 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 696 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 697 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 698
699 # Don't append another ";" when a valid category value is provided.
700 type=${type%;}${type:+;}
701
702 eshopts_push -s extglob
703 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
704 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
705 ewarn "allowed in .desktop files if the value is not an absolute path."
706 icon=${icon%.@(xpm|png|svg)}
707 fi
708 eshopts_pop
709
896 cat <<-EOF > "${desktop}" 710 cat <<-EOF > "${desktop}"
897 [Desktop Entry] 711 [Desktop Entry]
898 Version=1.0
899 Name=${name} 712 Name=${name}
900 Type=Application 713 Type=Application
901 Comment=${DESCRIPTION} 714 Comment=${DESCRIPTION}
902 Exec=${exec} 715 Exec=${exec}
903 TryExec=${exec%% *} 716 TryExec=${exec%% *}
904 Icon=${icon} 717 Icon=${icon}
905 Categories=${type}; 718 Categories=${type}
906 EOF 719 EOF
907 720
908 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 721 if [[ ${fields:-=} != *=* ]] ; then
722 # 5th arg used to be value to Path=
723 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
724 fields="Path=${fields}"
725 fi
726 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
909 727
910 ( 728 (
911 # wrap the env here so that the 'insinto' call 729 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller 730 # doesn't corrupt the env of the caller
913 insinto /usr/share/applications 731 insinto /usr/share/applications
914 doins "${desktop}" 732 doins "${desktop}"
915 ) 733 ) || die "installing desktop file failed"
916} 734}
917 735
918# @FUNCTION: validate_desktop_entries 736# @FUNCTION: validate_desktop_entries
919# @USAGE: [directories] 737# @USAGE: [directories]
920# @MAINTAINER: 738# @MAINTAINER:
942 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 760 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
943 fi 761 fi
944} 762}
945 763
946# @FUNCTION: make_session_desktop 764# @FUNCTION: make_session_desktop
947# @USAGE: <title> <command> 765# @USAGE: <title> <command> [command args...]
948# @DESCRIPTION: 766# @DESCRIPTION:
949# Make a GDM/KDM Session file. The title is the file to execute to start the 767# Make a GDM/KDM Session file. The title is the file to execute to start the
950# Window Manager. The command is the name of the Window Manager. 768# Window Manager. The command is the name of the Window Manager.
769#
770# You can set the name of the file via the ${wm} variable.
951make_session_desktop() { 771make_session_desktop() {
952 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 772 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
953 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 773 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
954 774
955 local title=$1 775 local title=$1
956 local command=$2 776 local command=$2
957 local desktop=${T}/${wm}.desktop 777 local desktop=${T}/${wm:-${PN}}.desktop
778 shift 2
958 779
959 cat <<-EOF > "${desktop}" 780 cat <<-EOF > "${desktop}"
960 [Desktop Entry] 781 [Desktop Entry]
961 Name=${title} 782 Name=${title}
962 Comment=This session logs you into ${title} 783 Comment=This session logs you into ${title}
963 Exec=${command} 784 Exec=${command} $*
964 TryExec=${command} 785 TryExec=${command}
965 Type=Application 786 Type=XSession
966 EOF 787 EOF
967 788
968 ( 789 (
969 # wrap the env here so that the 'insinto' call 790 # wrap the env here so that the 'insinto' call
970 # doesn't corrupt the env of the caller 791 # doesn't corrupt the env of the caller
1196 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1017 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1197 1018
1198 local shrtsrc=$(basename "${src}") 1019 local shrtsrc=$(basename "${src}")
1199 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1020 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1200 if [[ -z ${skip} ]] ; then 1021 if [[ -z ${skip} ]] ; then
1201 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1022 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1202 local skip=0 1023 local skip=0
1203 exe=tail 1024 exe=tail
1204 case ${ver} in 1025 case ${ver} in
1205 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1026 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1206 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1027 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1208 2.0|2.0.1) 1029 2.0|2.0.1)
1209 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1030 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1210 ;; 1031 ;;
1211 2.1.1) 1032 2.1.1)
1212 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1033 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1213 let skip="skip + 1" 1034 (( skip++ ))
1214 ;; 1035 ;;
1215 2.1.2) 1036 2.1.2)
1216 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1037 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1217 let skip="skip + 1" 1038 (( skip++ ))
1218 ;; 1039 ;;
1219 2.1.3) 1040 2.1.3)
1220 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1041 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1221 let skip="skip + 1" 1042 (( skip++ ))
1222 ;; 1043 ;;
1223 2.1.4|2.1.5) 1044 2.1.4|2.1.5)
1224 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1045 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1225 skip=$(head -n ${skip} "${src}" | wc -c) 1046 skip=$(head -n ${skip} "${src}" | wc -c)
1226 exe="dd" 1047 exe="dd"
1235 esac 1056 esac
1236 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1057 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1237 fi 1058 fi
1238 case ${exe} in 1059 case ${exe} in
1239 tail) exe="tail -n +${skip} '${src}'";; 1060 tail) exe="tail -n +${skip} '${src}'";;
1240 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1061 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1241 *) die "makeself cant handle exe '${exe}'" 1062 *) die "makeself cant handle exe '${exe}'"
1242 esac 1063 esac
1243 1064
1244 # lets grab the first few bytes of the file to figure out what kind of archive it is 1065 # lets grab the first few bytes of the file to figure out what kind of archive it is
1245 local tmpfile=$(emktemp) 1066 local filetype tmpfile=$(emktemp)
1246 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1067 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1247 local filetype=$(file -b "${tmpfile}") 1068 filetype=$(file -b "${tmpfile}") || die
1248 case ${filetype} in 1069 case ${filetype} in
1249 *tar\ archive*) 1070 *tar\ archive*)
1250 eval ${exe} | tar --no-same-owner -xf - 1071 eval ${exe} | tar --no-same-owner -xf -
1251 ;; 1072 ;;
1252 bzip2*) 1073 bzip2*)
1282 lic="${PWD}/${lic}" 1103 lic="${PWD}/${lic}"
1283 elif [ -e "${lic}" ] ; then 1104 elif [ -e "${lic}" ] ; then
1284 lic="${lic}" 1105 lic="${lic}"
1285 fi 1106 fi
1286 fi 1107 fi
1287 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1288 local l="`basename ${lic}`" 1108 local l="`basename ${lic}`"
1289 1109
1290 # here is where we check for the licenses the user already 1110 # here is where we check for the licenses the user already
1291 # accepted ... if we don't find a match, we make the user accept 1111 # accepted ... if we don't find a match, we make the user accept
1292 local shopts=$-
1293 local alic 1112 local alic
1294 set -o noglob #so that bash doesn't expand "*" 1113 eshopts_push -o noglob # so that bash doesn't expand "*"
1295 for alic in ${ACCEPT_LICENSE} ; do 1114 for alic in ${ACCEPT_LICENSE} ; do
1296 if [[ ${alic} == ${l} ]]; then 1115 if [[ ${alic} == ${l} ]]; then
1297 set +o noglob; set -${shopts} #reset old shell opts 1116 eshopts_pop
1298 return 0 1117 return 0
1299 fi 1118 fi
1300 done 1119 done
1301 set +o noglob; set -$shopts #reset old shell opts 1120 eshopts_pop
1121 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1302 1122
1303 local licmsg=$(emktemp) 1123 local licmsg=$(emktemp)
1304 cat <<-EOF > ${licmsg} 1124 cat <<-EOF > ${licmsg}
1305 ********************************************************** 1125 **********************************************************
1306 The following license outlines the terms of use of this 1126 The following license outlines the terms of use of this
1379 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1199 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1380 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1200 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1381 export CDROM_SET=-1 1201 export CDROM_SET=-1
1382 for f in ${CDROM_CHECK_1//:/ } ; do 1202 for f in ${CDROM_CHECK_1//:/ } ; do
1383 ((++CDROM_SET)) 1203 ((++CDROM_SET))
1384 [[ -e ${CD_ROOT}/${f} ]] && break 1204 [[ -e ${CDROM_ROOT}/${f} ]] && break
1385 done 1205 done
1386 export CDROM_MATCH=${f} 1206 export CDROM_MATCH=${f}
1387 return 1207 return
1388 fi 1208 fi
1389 1209
1553# of the lists. 1373# of the lists.
1554strip-linguas() { 1374strip-linguas() {
1555 local ls newls nols 1375 local ls newls nols
1556 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1376 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1557 local op=$1; shift 1377 local op=$1; shift
1558 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1378 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1559 local d f 1379 local d f
1560 for d in "$@" ; do 1380 for d in "$@" ; do
1561 if [[ ${op} == "-u" ]] ; then 1381 if [[ ${op} == "-u" ]] ; then
1562 newls=${ls} 1382 newls=${ls}
1563 else 1383 else
1564 newls="" 1384 newls=""
1565 fi 1385 fi
1566 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1386 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1567 if [[ ${op} == "-i" ]] ; then 1387 if [[ ${op} == "-i" ]] ; then
1568 hasq ${f} ${ls} && newls="${newls} ${f}" 1388 has ${f} ${ls} && newls="${newls} ${f}"
1569 else 1389 else
1570 hasq ${f} ${ls} || newls="${newls} ${f}" 1390 has ${f} ${ls} || newls="${newls} ${f}"
1571 fi 1391 fi
1572 done 1392 done
1573 ls=${newls} 1393 ls=${newls}
1574 done 1394 done
1575 else 1395 else
1577 fi 1397 fi
1578 1398
1579 nols="" 1399 nols=""
1580 newls="" 1400 newls=""
1581 for f in ${LINGUAS} ; do 1401 for f in ${LINGUAS} ; do
1582 if hasq ${f} ${ls} ; then 1402 if has ${f} ${ls} ; then
1583 newls="${newls} ${f}" 1403 newls="${newls} ${f}"
1584 else 1404 else
1585 nols="${nols} ${f}" 1405 nols="${nols} ${f}"
1586 fi 1406 fi
1587 done 1407 done
1588 [[ -n ${nols} ]] \ 1408 [[ -n ${nols} ]] \
1589 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1409 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1590 export LINGUAS=${newls:1} 1410 export LINGUAS=${newls:1}
1591} 1411}
1592 1412
1593# @FUNCTION: preserve_old_lib 1413# @FUNCTION: preserve_old_lib
1594# @USAGE: <libs to preserve> [more libs] 1414# @USAGE: <libs to preserve> [more libs]
1642 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1462 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1643 ewarn "in order to remove these old dependencies. If you do not have this" 1463 ewarn "in order to remove these old dependencies. If you do not have this"
1644 ewarn "helper program, simply emerge the 'gentoolkit' package." 1464 ewarn "helper program, simply emerge the 'gentoolkit' package."
1645 ewarn 1465 ewarn
1646 fi 1466 fi
1467 # temp hack for #348634 #357225
1468 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1647 ewarn " # revdep-rebuild --library ${lib##*/}" 1469 ewarn " # revdep-rebuild --library '${lib}'"
1648 done 1470 done
1649 if [[ ${notice} -eq 1 ]] ; then 1471 if [[ ${notice} -eq 1 ]] ; then
1650 ewarn 1472 ewarn
1651 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1473 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1652 ewarn "delete the old libraries. Here is a copy & paste for the lazy:" 1474 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1657} 1479}
1658 1480
1659# @FUNCTION: built_with_use 1481# @FUNCTION: built_with_use
1660# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1482# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1661# @DESCRIPTION: 1483# @DESCRIPTION:
1484#
1485# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1486#
1662# A temporary hack until portage properly supports DEPENDing on USE 1487# A temporary hack until portage properly supports DEPENDing on USE
1663# flags being enabled in packages. This will check to see if the specified 1488# flags being enabled in packages. This will check to see if the specified
1664# DEPEND atom was built with the specified list of USE flags. The 1489# DEPEND atom was built with the specified list of USE flags. The
1665# --missing option controls the behavior if called on a package that does 1490# --missing option controls the behavior if called on a package that does
1666# not actually support the defined USE flags (aka listed in IUSE). 1491# not actually support the defined USE flags (aka listed in IUSE).
1794 ) || die 1619 ) || die
1795 else 1620 else
1796 newbin "${tmpwrapper}" "${wrapper}" || die 1621 newbin "${tmpwrapper}" "${wrapper}" || die
1797 fi 1622 fi
1798} 1623}
1624
1625# @FUNCTION: path_exists
1626# @USAGE: [-a|-o] <paths>
1627# @DESCRIPTION:
1628# Check if the specified paths exist. Works for all types of paths
1629# (files/dirs/etc...). The -a and -o flags control the requirements
1630# of the paths. They correspond to "and" and "or" logic. So the -a
1631# flag means all the paths must exist while the -o flag means at least
1632# one of the paths must exist. The default behavior is "and". If no
1633# paths are specified, then the return value is "false".
1634path_exists() {
1635 local opt=$1
1636 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1637
1638 # no paths -> return false
1639 # same behavior as: [[ -e "" ]]
1640 [[ $# -eq 0 ]] && return 1
1641
1642 local p r=0
1643 for p in "$@" ; do
1644 [[ -e ${p} ]]
1645 : $(( r += $? ))
1646 done
1647
1648 case ${opt} in
1649 -a) return $(( r != 0 )) ;;
1650 -o) return $(( r == $# )) ;;
1651 esac
1652}
1653
1654# @FUNCTION: in_iuse
1655# @USAGE: <flag>
1656# @DESCRIPTION:
1657# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1658# as necessary.
1659#
1660# Note that this function should not be used in the global scope.
1661in_iuse() {
1662 debug-print-function ${FUNCNAME} "${@}"
1663 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1664
1665 local flag=${1}
1666 local liuse=( ${IUSE} )
1667
1668 has "${flag}" "${liuse[@]#[+-]}"
1669}
1670
1671# @FUNCTION: use_if_iuse
1672# @USAGE: <flag>
1673# @DESCRIPTION:
1674# Return true if the given flag is in USE and IUSE.
1675#
1676# Note that this function should not be used in the global scope.
1677use_if_iuse() {
1678 in_iuse $1 || return 1
1679 use $1
1680}
1681
1682# @FUNCTION: usex
1683# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1684# @DESCRIPTION:
1685# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1686# otherwise echo [false output][false suffix] (defaults to "no").
1687usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.304  
changed lines
  Added in v.1.370

  ViewVC Help
Powered by ViewVC 1.1.20